diff --git a/lib/outputrenderers.php b/lib/outputrenderers.php
index 36159a8..2e5175a 100644
--- a/lib/outputrenderers.php
+++ b/lib/outputrenderers.php
@@ -1801,173 +1801,6 @@ END;
     }
 
     /**
-     * Render a HTML table
-     *
-     * @param object $table {@link html_table} instance containing all the information needed
-     * @return string the HTML to output.
-     */
-    public function table(html_table $table) {
-        $table = clone($table);
-        $table->prepare($this, $this->page, $this->target);
-        $attributes = array(
-                'id'            => $table->id,
-                'width'         => $table->width,
-                'summary'       => $table->summary,
-                'cellpadding'   => $table->cellpadding,
-                'cellspacing'   => $table->cellspacing,
-                'class'         => $table->get_classes_string());
-        $output = html_writer::start_tag('table', $attributes) . "\n";
-
-        $countcols = 0;
-
-        if (!empty($table->head)) {
-            $countcols = count($table->head);
-            $output .= html_writer::start_tag('thead', $table->headclasses) . "\n";
-            $output .= html_writer::start_tag('tr', array()) . "\n";
-            $keys = array_keys($table->head);
-            $lastkey = end($keys);
-
-            foreach ($table->head as $key => $heading) {
-                // Convert plain string headings into html_table_cell objects
-                if (!($heading instanceof html_table_cell)) {
-                    $headingtext = $heading;
-                    $heading = new html_table_cell();
-                    $heading->text = $headingtext;
-                    $heading->header = true;
-                }
-
-                if ($heading->header !== false) {
-                    $heading->header = true;
-                }
-
-                $heading->add_classes(array('header', 'c' . $key));
-                if (isset($table->headspan[$key]) && $table->headspan[$key] > 1) {
-                    $heading->colspan = $table->headspan[$key];
-                    $countcols += $table->headspan[$key] - 1;
-                }
-
-                if ($key == $lastkey) {
-                    $heading->add_class('lastcol');
-                }
-                if (isset($table->colclasses[$key])) {
-                    $heading->add_class($table->colclasses[$key]);
-                }
-                if ($table->rotateheaders) {
-                    // we need to wrap the heading content
-                    $heading->text = html_writer::tag('span', $heading->text);
-                }
-
-                $attributes = array(
-                        'style'     => $table->align[$key] . $table->size[$key] . $heading->style,
-                        'class'     => $heading->get_classes_string(),
-                        'scope'     => $heading->scope,
-                        'colspan'   => $heading->colspan);
-
-                $tagtype = 'td';
-                if ($heading->header === true) {
-                    $tagtype = 'th';
-                }
-                $output .= html_writer::tag($tagtype, $heading->text, $attributes) . "\n";
-            }
-            $output .= html_writer::end_tag('tr') . "\n";
-            $output .= html_writer::end_tag('thead') . "\n";
-
-            if (empty($table->data)) {
-                // For valid XHTML strict every table must contain either a valid tr
-                // or a valid tbody... both of which must contain a valid td
-                $output .= html_writer::start_tag('tbody', array('class' => renderer_base::prepare_classes($table->bodyclasses).' empty'));
-                $output .= html_writer::tag('tr', html_writer::tag('td', '', array('colspan'=>count($table->head))));
-                $output .= html_writer::end_tag('tbody');
-            }
-        }
-
-        if (!empty($table->data)) {
-            $oddeven    = 1;
-            $keys       = array_keys($table->data);
-            $lastrowkey = end($keys);
-            $output .= html_writer::start_tag('tbody', array('class' => renderer_base::prepare_classes($table->bodyclasses))) . "\n";
-
-            foreach ($table->data as $key => $row) {
-                if (($row === 'hr') && ($countcols)) {
-                    $output .= html_writer::tag('td', html_writer::tag('div', '', array('class' => 'tabledivider')), array('colspan' => $countcols)) . "\n";
-                } else {
-                    // Convert array rows to html_table_rows and cell strings to html_table_cell objects
-                    if (!($row instanceof html_table_row)) {
-                        $newrow = new html_table_row();
-
-                        foreach ($row as $unused => $item) {
-                            $cell = new html_table_cell();
-                            $cell->text = $item;
-                            $newrow->cells[] = $cell;
-                        }
-                        $row = $newrow;
-                    }
-
-                    $oddeven = $oddeven ? 0 : 1;
-                    if (isset($table->rowclasses[$key])) {
-                        $row->add_classes(array_unique(html_component::clean_classes($table->rowclasses[$key])));
-                    }
-
-                    $row->add_class('r' . $oddeven);
-                    if ($key == $lastrowkey) {
-                        $row->add_class('lastrow');
-                    }
-
-                    $output .= html_writer::start_tag('tr', array('class' => $row->get_classes_string(), 'style' => $row->style, 'id' => $row->id)) . "\n";
-                    $keys2 = array_keys($row->cells);
-                    $lastkey = end($keys2);
-
-                    foreach ($row->cells as $key => $cell) {
-                        if (!($cell instanceof html_table_cell)) {
-                            $mycell = new html_table_cell();
-                            $mycell->text = $cell;
-                            $cell = $mycell;
-                        }
-
-                        if (isset($table->colclasses[$key])) {
-                            $cell->add_classes(array_unique(html_component::clean_classes($table->colclasses[$key])));
-                        }
-
-                        $cell->add_classes('cell');
-                        $cell->add_classes('c' . $key);
-                        if ($key == $lastkey) {
-                            $cell->add_classes('lastcol');
-                        }
-                        $tdstyle = '';
-                        $tdstyle .= isset($table->align[$key]) ? $table->align[$key] : '';
-                        $tdstyle .= isset($table->size[$key]) ? $table->size[$key] : '';
-                        $tdstyle .= isset($table->wrap[$key]) ? $table->wrap[$key] : '';
-                        $tdattributes = array(
-                                'style' => $tdstyle . $cell->style,
-                                'colspan' => $cell->colspan,
-                                'rowspan' => $cell->rowspan,
-                                'id' => $cell->id,
-                                'class' => $cell->get_classes_string(),
-                                'abbr' => $cell->abbr,
-                                'scope' => $cell->scope,
-                                'title' => $cell->title);
-                        $tagtype = 'td';
-                        if ($cell->header === true) {
-                            $tagtype = 'th';
-                        }
-                        $output .= html_writer::tag($tagtype, $cell->text, $tdattributes) . "\n";
-                    }
-                }
-                $output .= html_writer::end_tag('tr') . "\n";
-            }
-            $output .= html_writer::end_tag('tbody') . "\n";
-        }
-        $output .= html_writer::end_tag('table') . "\n";
-
-        if ($table->rotateheaders && can_use_rotated_text()) {
-            $this->page->requires->yui2_lib('event');
-            $this->page->requires->js('/course/report/progress/textrotate.js');
-        }
-
-        return $output;
-    }
-
-    /**
      * Output the place a skip link goes to.
      * @param string $id The target name from the corresponding $PAGE->requires->skip_link_to($target) call.
      * @return string the HTML to output.
diff --git a/lib/portfolio/exporter.php b/lib/portfolio/exporter.php
index 99c6b7c..3af9296 100644
--- a/lib/portfolio/exporter.php
+++ b/lib/portfolio/exporter.php
@@ -423,7 +423,7 @@ class portfolio_exporter {
         foreach ($mainsummary as $string => $value) {
             $table->data[] = array($string, $value);
         }
-        echo $OUTPUT->table($table);
+        echo html_writer::table($table);
         echo $OUTPUT->confirm($strconfirm, $yesurl, $nourl);
         echo $OUTPUT->box_end();
         echo $OUTPUT->footer();
diff --git a/lib/portfoliolib.php b/lib/portfoliolib.php
index 828158c..1dda06e 100644
--- a/lib/portfoliolib.php
+++ b/lib/portfoliolib.php
@@ -894,7 +894,7 @@ function portfolio_report_insane($insane, $instances=false, $return=false) {
         }
         $table->data[] = array($name, get_string($reason, 'portfolio_' . $plugin));
     }
-    $output .= $OUTPUT->table($table);
+    $output .= html_writer::table($table);
     $output .= '<br /><br /><br />';
 
     if ($return) {
diff --git a/lib/questionlib.php b/lib/questionlib.php
index 82c14c0..efb0224 100644
--- a/lib/questionlib.php
+++ b/lib/questionlib.php
@@ -672,7 +672,7 @@ function question_delete_course($course, $feedback=true) {
             $table = new html_table();
             $table->head = array(get_string('category','quiz'), get_string('action'));
             $table->data = $feedbackdata;
-            echo $OUTPUT->table($table);
+            echo html_writer::table($table);
         }
     }
     return true;
@@ -738,7 +738,7 @@ function question_delete_course_category($category, $newcategory, $feedback=true
             $table = new html_table();
             $table->head = array(get_string('questioncategory','question'), get_string('action'));
             $table->data = $feedbackdata;
-            echo $OUTPUT->table($table);
+            echo html_writer::table($table);
         }
 
     } else {
@@ -835,7 +835,7 @@ function question_delete_activity($cm, $feedback=true) {
             $table = new html_table();
             $table->head = array(get_string('category','quiz'), get_string('action'));
             $table->data = $feedbackdata;
-            echo $OUTPUT->table($table);
+            echo html_writer::table($table);
         }
     }
     return true;
diff --git a/lib/simpletestcoveragelib.php b/lib/simpletestcoveragelib.php
index db9e9b5..ee19a0c 100644
--- a/lib/simpletestcoveragelib.php
+++ b/lib/simpletestcoveragelib.php
@@ -433,7 +433,7 @@ class moodle_coverage_reporter extends HtmlCoverageReporter {
                 $table = new html_table();
                 $table->align = array('right', 'left');
                 $table->tablealign = 'center';
-                $table->add_class('codecoveragetable');
+                $table->attributes['class'] = 'codecoveragetable';
                 $table->id = 'codecoveragetable_' . $type;
                 $table->rowclasses = array('label', 'value');
                 $table->data = array(
@@ -450,7 +450,7 @@ class moodle_coverage_reporter extends HtmlCoverageReporter {
                 $result .= $OUTPUT->heading($data->title, 3, 'main codecoverageheading');
                 $result .= $OUTPUT->heading('<a href="' . $url . '" onclick="javascript:window.open(' . "'" . $url . "'" . ');return false;"' .
                                    ' title="">' . get_string('codecoveragecompletereport', 'simpletest') . '</a>', 4, 'main codecoveragelink');
-                $result .= $OUTPUT->table($table);
+                $result .= html_writer::table($table);
 
                 return $OUTPUT->box($result, 'generalbox boxwidthwide boxaligncenter codecoveragebox', '', true);
             }
diff --git a/mod/assignment/index.php b/mod/assignment/index.php
index 939cd88..eb391dc 100644
--- a/mod/assignment/index.php
+++ b/mod/assignment/index.php
@@ -118,6 +118,6 @@ foreach ($modinfo->instances['assignment'] as $cm) {
 
 echo "<br />";
 
-echo $OUTPUT->table($table);
+echo html_writer::table($table);
 
 echo $OUTPUT->footer();
\ No newline at end of file
diff --git a/mod/chat/gui_ajax/index.php b/mod/chat/gui_ajax/index.php
index 67cd8c4..a034123 100644
--- a/mod/chat/gui_ajax/index.php
+++ b/mod/chat/gui_ajax/index.php
@@ -79,7 +79,7 @@ $table->data = array(
         '<a id="choosetheme" href="###">'.get_string('themes').' ▶</a>'
     )
 );
-echo $OUTPUT->box($OUTPUT->table($table), '', 'chat-input-area');
+echo $OUTPUT->box(html_writer::table($table), '', 'chat-input-area');
 echo $OUTPUT->box('', '', 'chat-notify');
 echo $OUTPUT->footer();
 
diff --git a/mod/chat/gui_header_js/users.php b/mod/chat/gui_header_js/users.php
index 1b36979..8dec6be 100644
--- a/mod/chat/gui_header_js/users.php
+++ b/mod/chat/gui_header_js/users.php
@@ -106,7 +106,7 @@ foreach ($chatusers as $chatuser) {
 ob_start();
 echo $OUTPUT->header();
 echo html_writer::tag('div', html_writer::tag('a', 'Refresh link', array('href'=>$refreshurl, 'id'=>'refreshLink')), array('style'=>'display:none')); //TODO: localize
-echo $OUTPUT->table($table);
+echo html_writer::table($table);
 echo $OUTPUT->footer();
 
 //
diff --git a/mod/chat/index.php b/mod/chat/index.php
index 72a8751..2a773c1 100644
--- a/mod/chat/index.php
+++ b/mod/chat/index.php
@@ -83,7 +83,7 @@ foreach ($chats as $chat) {
 
 echo '<br />';
 
-echo $OUTPUT->table($table);
+echo html_writer::table($table);
 
 /// Finish the page
 
diff --git a/mod/choice/index.php b/mod/choice/index.php
index a3712f0..e391759 100644
--- a/mod/choice/index.php
+++ b/mod/choice/index.php
@@ -94,7 +94,7 @@
         }
     }
     echo "<br />";
-    echo $OUTPUT->table($table);
+    echo html_writer::table($table);
 
     echo $OUTPUT->footer();
 
diff --git a/mod/data/field.php b/mod/data/field.php
index bcc6a2e..c22b6d9 100755
--- a/mod/data/field.php
+++ b/mod/data/field.php
@@ -298,7 +298,7 @@ if (($mode == 'new') && (!empty($newtype)) && confirm_sesskey()) {          ///
                 );
             }
         }
-        echo $OUTPUT->table($table);
+        echo html_writer::table($table);
     }
 
 
diff --git a/mod/data/index.php b/mod/data/index.php
index 3d2b2fb..21327a3 100755
--- a/mod/data/index.php
+++ b/mod/data/index.php
@@ -141,6 +141,6 @@ foreach ($datas as $data) {
 }
 
 echo "<br />";
-echo $OUTPUT->table($table);
+echo html_writer::table($table);
 echo $OUTPUT->footer();
 
diff --git a/mod/feedback/index.php b/mod/feedback/index.php
index ddb1ce2..a5b2ae6 100644
--- a/mod/feedback/index.php
+++ b/mod/feedback/index.php
@@ -108,7 +108,7 @@ foreach ($feedbacks as $feedback) {
 
 echo "<br />";
 
-echo $OUTPUT->table($table);
+echo html_writer::table($table);
 
 /// Finish the page
 
diff --git a/mod/folder/index.php b/mod/folder/index.php
index b3633d5..6e5a418 100644
--- a/mod/folder/index.php
+++ b/mod/folder/index.php
@@ -54,7 +54,7 @@ if (!$folders = get_all_instances_in_course('folder', $course)) {
 }
 
 $table = new html_table();
-$table->set_classes(array('generaltable', 'mod_index'));
+$table->attributes['class'] = 'generaltable mod_index';
 
 if ($course->format == 'weeks') {
     $table->head  = array ($strweek, $strname, $strintro);
@@ -93,6 +93,6 @@ foreach ($folders as $folder) {
         format_module_intro('folder', $folder, $cm->id));
 }
 
-echo $OUTPUT->table($table);
+echo html_writer::table($table);
 
 echo $OUTPUT->footer();
diff --git a/mod/forum/index.php b/mod/forum/index.php
index 3581736..965a2a6 100644
--- a/mod/forum/index.php
+++ b/mod/forum/index.php
@@ -421,12 +421,12 @@ if (!isguestuser()) {
 
 if ($generalforums) {
     echo $OUTPUT->heading(get_string('generalforums', 'forum'));
-    echo $OUTPUT->table($generaltable);
+    echo html_writer::table($generaltable);
 }
 
 if ($learningforums) {
     echo $OUTPUT->heading(get_string('learningforums', 'forum'));
-    echo $OUTPUT->table($learningtable);
+    echo html_writer::table($learningtable);
 }
 
 echo $OUTPUT->footer();
diff --git a/mod/forum/renderer.php b/mod/forum/renderer.php
index 8053d18..3463504 100644
--- a/mod/forum/renderer.php
+++ b/mod/forum/renderer.php
@@ -51,22 +51,22 @@ class mod_forum_renderer extends plugin_renderer_base {
 
         $existingcell = new html_table_cell();
         $existingcell->text = $existinguc->display(true);
-        $existingcell->set_classes(array('existing'));
+        $existingcell->attributes['class'] = 'existing';
         $actioncell = new html_table_cell();
         $actioncell->text  = html_writer::start_tag('div', array());
         $actioncell->text .= html_writer::empty_tag('input', array('type'=>'submit', 'name'=>'subscribe', 'value'=>$this->page->theme->larrow.' '.get_string('add'), 'class'=>'actionbutton'));
         $actioncell->text .= html_writer::empty_tag('br', array());
         $actioncell->text .= html_writer::empty_tag('input', array('type'=>'submit', 'name'=>'unsubscribe', 'value'=>$this->page->theme->rarrow.' '.get_string('remove'), 'class'=>'actionbutton'));
         $actioncell->text .= html_writer::end_tag('div', array());
-        $actioncell->set_classes(array('actions'));
+        $actioncell->attributes['class'] = 'actions';
         $potentialcell = new html_table_cell();
         $potentialcell->text = $potentialuc->display(true);
-        $potentialcell->set_classes(array('potential'));
+        $potentialcell->attributes['class'] = 'potential';
 
         $table = new html_table();
-        $table->set_classes(array('subscribertable','boxaligncenter'));
+        $table->attributes['class'] = 'subscribertable boxaligncenter';
         $table->data = array(new html_table_row(array($existingcell, $actioncell, $potentialcell)));
-        $output .= $this->output->table($table);
+        $output .= html_writer::table($table);
 
         $output .= html_writer::end_tag('form');
         return $output;
@@ -95,7 +95,7 @@ class mod_forum_renderer extends plugin_renderer_base {
             foreach ($users as $user) {
                 $table->data[] = array($this->output->user_picture($user, array('courseid'=>$course->id)), fullname($user), $user->email);
             }
-            $output .= $this->output->table($table);
+            $output .= html_writer::table($table);
         }
         return $output;
     }
@@ -116,4 +116,4 @@ class mod_forum_renderer extends plugin_renderer_base {
     }
 
 
-}
\ No newline at end of file
+}
diff --git a/mod/glossary/index.php b/mod/glossary/index.php
index 58d69eb..a517b67 100644
--- a/mod/glossary/index.php
+++ b/mod/glossary/index.php
@@ -128,7 +128,7 @@ foreach ($glossarys as $glossary) {
 
 echo "<br />";
 
-echo $OUTPUT->table($table);
+echo html_writer::table($table);
 
 /// Finish the page
 
diff --git a/mod/hotpot/index.php b/mod/hotpot/index.php
index 7a37cdf..a44c5fd 100644
--- a/mod/hotpot/index.php
+++ b/mod/hotpot/index.php
@@ -399,7 +399,7 @@
 
     echo "<br />";
 
-    echo $OUTPUT->table($table);
+    echo html_writer::table($table);
 
     // Finish the page
     echo $OUTPUT->footer();
diff --git a/mod/imscp/index.php b/mod/imscp/index.php
index 122fb0e..c6e59dd 100644
--- a/mod/imscp/index.php
+++ b/mod/imscp/index.php
@@ -54,7 +54,7 @@ if (!$imscps = get_all_instances_in_course('imscp', $course)) {
 }
 
 $table = new html_table();
-$table->set_classes(array('generaltable', 'mod_index'));
+$table->attributes['class'] = 'generaltable mod_index';
 
 if ($course->format == 'weeks') {
     $table->head  = array ($strweek, $strname, $strintro);
@@ -93,6 +93,6 @@ foreach ($imscps as $imscp) {
         format_module_intro('imscp', $imscp, $cm->id));
 }
 
-echo $OUTPUT->table($table);
+echo html_writer::table($table);
 
 echo $OUTPUT->footer();
diff --git a/mod/lesson/essay.php b/mod/lesson/essay.php
index 7090259..3c54fe7 100644
--- a/mod/lesson/essay.php
+++ b/mod/lesson/essay.php
@@ -296,7 +296,7 @@ switch ($mode) {
         // Setup table
         $table = new html_table();
         $table->head = array(get_string('name'), get_string('essays', 'lesson'), get_string('email', 'lesson'));
-        $table->set_classes(array('standardtable', 'generaltable'));
+        $table->attributes['class'] = 'standardtable generaltable';
         $table->align = array('left', 'left', 'left');
         $table->wrap = array('nowrap', 'nowrap', '');
 
@@ -356,7 +356,7 @@ switch ($mode) {
 
         $table->data[] = array(' ', ' ', $emailalllink);
 
-        echo $OUTPUT->table($table);
+        echo html_writer::table($table);
         break;
     case 'grade':
         // Grading form
diff --git a/mod/lesson/highscores.php b/mod/lesson/highscores.php
index bf87a87..cfaadf6 100644
--- a/mod/lesson/highscores.php
+++ b/mod/lesson/highscores.php
@@ -208,7 +208,7 @@ switch ($mode) {
                     break;
                 }
             }
-            echo $OUTPUT->table($table);
+            echo html_writer::table($table);
         }
 
         if (!has_capability('mod/lesson:manage', $context)) {  // teachers don't need the links
diff --git a/mod/lesson/index.php b/mod/lesson/index.php
index 452e3f5..6f87d2b 100644
--- a/mod/lesson/index.php
+++ b/mod/lesson/index.php
@@ -116,5 +116,5 @@ foreach ($lessons as $lesson) {
         $table->data[] = array ($link, $lesson->grade, $due);
     }
 }
-echo $OUTPUT->table($table);
+echo html_writer::table($table);
 echo $OUTPUT->footer();
\ No newline at end of file
diff --git a/mod/lesson/lib.php b/mod/lesson/lib.php
index e576a93..af8a0ed 100644
--- a/mod/lesson/lib.php
+++ b/mod/lesson/lib.php
@@ -235,7 +235,7 @@ function lesson_user_complete($course, $user, $mod, $lesson) {
         if ($npages) {
                 $table->data[] = array($retry + 1, $npages, $ncorrect, userdate($timeseen));
         }
-        echo $OUTPUT->table($table);
+        echo html_writer::table($table);
         echo $OUTPUT->box_end();
     }
 
diff --git a/mod/lesson/renderer.php b/mod/lesson/renderer.php
index d0cd48e..d8f28d3 100644
--- a/mod/lesson/renderer.php
+++ b/mod/lesson/renderer.php
@@ -228,7 +228,7 @@ class mod_lesson_renderer extends plugin_renderer_base {
             $pageid = $page->nextpageid;
         }
 
-        return $this->output->table($table);
+        return html_writter::table($table);
     }
 
     /**
@@ -292,7 +292,7 @@ class mod_lesson_renderer extends plugin_renderer_base {
 
             $pagetable = $page->display_answers($pagetable);
 
-            $content .= $this->output->table($pagetable);
+            $content .= html_writer::table($pagetable);
 
             if ($canedit) {
                 $content .= $this->add_page_links($lesson, $pageid);
@@ -539,16 +539,16 @@ class mod_lesson_renderer extends plugin_renderer_base {
         if ($progress != 0) {  // some browsers do not repsect the 0 width.
             $cells[0] = new html_table_cell();
             $cells[0]->style = 'width:'.$progress.'%';
-            $cells[0]->set_classes('progress_bar_completed');
+            $cells[0]->attributes['class'] = 'progress_bar_completed';
             $cells[0]->text = ' ';
         }
         $cells[] = '<div class="progress_bar_token"></div>';
 
         $table = new html_table();
-        $table->set_classes(array('progress_bar_table', 'center'));
+        $table->attributes['class'] = 'progress_bar_table';
         $table->data = array(new html_table_row($cells));
 
-        return $this->output->box($this->output->table($table), 'progress_bar');
+        return $this->output->box(html_writer::table($table), 'progress_bar');
     }
 
     /**
@@ -599,4 +599,4 @@ class mod_lesson_renderer extends plugin_renderer_base {
         $output .= $this->output->box_end();
         return $output;
     }
-}
\ No newline at end of file
+}
diff --git a/mod/lesson/report.php b/mod/lesson/report.php
index d1a6c49..f7120b6 100644
--- a/mod/lesson/report.php
+++ b/mod/lesson/report.php
@@ -221,10 +221,10 @@ if ($action == 'reportoverview') {
 
     // set up the table object
     $table->head = array(get_string('name'), get_string('attempts', 'lesson'), get_string('highscore', 'lesson'));
-    $table->align = array("center", "left", "left");
-    $table->wrap = array("nowrap", "nowrap", "nowrap");
-    $table->set_classes(array('standardtable', 'generaltable'));
-    $table->size = array("*", "70%", "*");
+    $table->align = array('center', 'left', 'left');
+    $table->wrap = array('nowrap', 'nowrap', 'nowrap');
+    $table->attributes['class'] = 'standardtable generaltable';
+    $table->size = array(null, '70%', null);
 
     // print out the $studentdata array
     // going through each student that has attempted the lesson, so, each student should have something to be displayed
@@ -299,7 +299,7 @@ if ($action == 'reportoverview') {
                <input type=\"hidden\" name=\"sesskey\" value=\"".sesskey()."\" />\n
                <input type=\"hidden\" name=\"id\" value=\"$cm->id\" />\n";
     }
-    echo $OUTPUT->table($table);
+    echo html_writer::table($table);
     if (has_capability('mod/lesson:edit', $context)) {
         $checklinks  = '<a href="javascript: checkall();">'.get_string('selectall').'</a> / ';
         $checklinks .= '<a href="javascript: checknone();">'.get_string('deselectall').'</a>';
@@ -344,12 +344,12 @@ if ($action == 'reportoverview') {
     $stattable->head = array(get_string('averagescore', 'lesson'), get_string('averagetime', 'lesson'),
                             get_string('highscore', 'lesson'), get_string('lowscore', 'lesson'),
                             get_string('hightime', 'lesson'), get_string('lowtime', 'lesson'));
-    $stattable->align = array("center", "center", "center", "center", "center", "center");
-    $stattable->wrap = array("nowrap", "nowrap", "nowrap", "nowrap", "nowrap", "nowrap");
-    $stattable->set_classes(array('standardtable', 'generaltable'));
+    $stattable->align = array('center', 'center', 'center', 'center', 'center', 'center');
+    $stattable->wrap = array('nowrap', 'nowrap', 'nowrap', 'nowrap', 'nowrap', 'nowrap');
+    $stattable->attributes['class'] = 'standardtable generaltable';
     $stattable->data[] = array($avescore.'%', $avetime, $highscore.'%', $lowscore.'%', $hightime, $lowtime);
 
-    echo $OUTPUT->table($stattable);
+    echo html_writer::table($stattable);
 } else if ($action == 'reportdetail') {
     /**************************************************************************
     this action is for a student detailed view and for the general detailed view
@@ -475,8 +475,8 @@ if ($action == 'reportoverview') {
         echo $OUTPUT->heading(get_string('attempt', 'lesson', $try+1));
 
         $table->head = array();
-        $table->align = array("right", "left");
-        $table->set_classes(array('compacttable', 'generaltable'));
+        $table->align = array('right', 'left');
+        $table->attributes['class'] = 'compacttable generaltable';
 
         $params = array("lessonid"=>$lesson->id, "userid"=>$userid);
         if (!$grades = $DB->get_records_select("lesson_grades", "lessonid = :lessonid and userid = :userid", $params, "completed", "*", $try, 1)) {
@@ -509,16 +509,16 @@ if ($action == 'reportoverview') {
             $table->data[] = array(get_string('rawgrade', 'lesson').':', $gradeinfo->earned.'/'.$gradeinfo->total);
             $table->data[] = array(get_string("grade", "lesson").":", $grade."%");
         }
-        echo $OUTPUT->table($table);
+        echo html_writer::table($table);
 
         // Don't want this class for later tables
-        $table->set_classes(array());
+        $table->attributes['class'] = '';
     }
 
 
-    $table->align = array("left", "left");
-    $table->size = array("70%", "*");
-    $table->set_classes(array('compacttable', 'generaltable'));
+    $table->align = array('left', 'left');
+    $table->size = array('70%', null);
+    $table->attributes['class'] = 'compacttable generaltable';
 
     foreach ($answerpages as $page) {
         unset($table->data);
@@ -554,7 +554,7 @@ if ($action == 'reportoverview') {
         } else {
             $table->data[] = array(0, " ");
         }
-        echo $OUTPUT->table($table);
+        echo html_writer::table($table);
     }
 } else {
     print_error('unknowaction');
diff --git a/mod/page/index.php b/mod/page/index.php
index 3d4b51a..391e63b 100644
--- a/mod/page/index.php
+++ b/mod/page/index.php
@@ -54,7 +54,7 @@ if (!$pages = get_all_instances_in_course('page', $course)) {
 }
 
 $table = new html_table();
-$table->set_classes(array('generaltable', 'mod_index'));
+$table->attributes['class'] = 'generaltable mod_index';
 
 if ($course->format == 'weeks') {
     $table->head  = array ($strweek, $strname, $strintro);
@@ -94,6 +94,6 @@ foreach ($pages as $page) {
         format_module_intro('page', $page, $cm->id));
 }
 
-echo $OUTPUT->table($table);
+echo html_writer::table($table);
 
 echo $OUTPUT->footer();
diff --git a/mod/quiz/index.php b/mod/quiz/index.php
index 206ed01..1327404 100644
--- a/mod/quiz/index.php
+++ b/mod/quiz/index.php
@@ -166,7 +166,7 @@
 
 // Display the table.
     echo '<br />';
-    echo $OUTPUT->table($table);
+    echo html_writer::table($table);
 
 // Finish the page
     echo $OUTPUT->footer();
diff --git a/mod/quiz/overrides.php b/mod/quiz/overrides.php
index b595b49..c2c081f 100644
--- a/mod/quiz/overrides.php
+++ b/mod/quiz/overrides.php
@@ -199,7 +199,7 @@ foreach ($overrides as $override) {
 
 echo html_writer::start_tag('div', array('id' => 'quizoverrides'));
 if (count($table->data)) {
-    echo $OUTPUT->table($table);
+    echo html_writer::table($table);
 }
 
 echo html_writer::start_tag('div', array('class' => 'buttons'));
